module Maglove
  module Widgets
    class Base
      extend Forwardable
      include Hamloft::Helpers
      attr_reader :options, :scope
      def_delegators :@scope, :haml_tag, :haml_concat

      def identifier
        "base"
      end

      def defaults
        {}
      end

      def initialize(options, scope)
        @options = defaults.merge(options)
        @scope = scope
      end

      def widget_options
        attributes = { widget: true }
        @options.each do |key, value|
          attributes[key.to_s.dasherize.to_s] = value
        end
        if attributes["padding"]
          attributes["padding"] = attributes["padding"].join(" ")
        else
          attributes["padding"] = "0 0 0 0"
        end
        attributes
      end
    end
  end
end
